;Source code for Alien Blitz version 1.00 by Shane Kennedy


AppTitle "Alien Blitz by Shane Kennedy","Exit Alien Blitz?"

;constants
Const buildingtypes = 3
Const ScrWidth = 640
Const ScrHeight = 480


;variables
Dim BuildingArray(ScrWidth/20,2*ScrHeight/60)
Global ContinueGame = True
Global startgame = False
Global nextlevel = False
Global missilerange
Global level
Global startheight
Global score
Global bestscore


;graphics
Global MenuBackground
Global GameBackground
Global ufo
Global missile
Global skyscraper


;sounds
Global ufo_sound
Global missile_sound
Global explosion_sound


;environment
Graphics ScrWidth,ScrHeight,0,2
SeedRnd MilliSecs() 


;mainloop
LoadAll()
While ContinueGame
	If Not nextlevel Then
		Menu()
	End If
	Initialise()
	If startgame Then
		PlayGame()
	Else
		ContinueGame = False
	End If
Wend
ExitGame()


Function LoadAll()
	
	MenuBackground = LoadImage("Media\Menu.jpg")

	ufo = LoadImage("Media\UFO.bmp")
	
	GameBackground = LoadImage("Media\Background.jpg")

	missile = LoadImage("Media\missile.bmp")
	
	skyscraper = LoadAnimImage("Media\Buildings.bmp",20,20,0,9)
	MaskImage skyscraper,255,0,255
	
	ufo_sound = LoadSound("Media\ufo.wav")
	missile_sound = LoadSound("Media\missile.wav")
	explosion_sound = LoadSound("Media\explosion.wav")
	SoundVolume missile_sound,0.8
	SoundVolume explosion_sound,0.5
	
	;load all player data
	If FileType("Blitz.dat")=1 Then
		UserDataFile = ReadFile("Blitz.dat")
		bestscore = ReadShort(UserDataFile)
		CloseFile(UserDataFile)
	Else
		bestscore = 0
	End If

End Function

Function Initialise()

	level = level + 1
	
	For i = 2 To ScrWidth/20-1
		top = Rand(2, 2*ScrHeight/60-3)
		btype = Rand(0, buildingtypes-1)
		For j = 1 To 2*ScrHeight/60
			If j < top Then BuildingArray(i,j) = btype*3+1
			If j = top Then BuildingArray(i,top) = btype*3+2
			If j > top Then BuildingArray(i,j) = 0
		Next
	Next
	
	startheight = ImageHeight(ufo) * (level + 1)
	
	missilerange = 200 - level * 20 

	SetBuffer BackBuffer()

	ClsColor 128,128,255
	
End Function

Function Menu()

	level = 0
	score = 0
	
	Repeat 
	
		DrawBlock MenuBackground,0,0
		
		If KeyHit(57) Then
			startgame = True
			Exit
		End If
		
		If KeyHit(1) Then
			startgame = False
			Exit
		End If
		
		If MouseHit(1) And MouseY() > 460 Then
			ExecFile("http://www.dpw-shane.pwp.blueyonder.co.uk")
		End If
		
		Flip
	
	Forever

End Function

Function PlayGame()

	py = startheight
	
	frameTimer = CreateTimer(60)
	
	chnUfo = PlaySound(ufo_sound)

	Repeat

		WaitTimer(frameTimer)
		
		DrawBlock GameBackground,0,0
	
		DrawImage ufo, px, py
		
		Text 560,0,"level: " + level
		
		Text 0,0,"score: " + score
		
		Color 240,240,0
		Text 0,FontHeight(),"high score: " + bestscore
		Color 255,255,255
		
		If ChannelPlaying(chnUfo) = 0 And (Not gameover) And (Not gamewon) Then
			chnUfo = PlaySound(ufo_sound)
		End If
	
		If showmissile And (Not gameover) And (Not gamewon) Then
			DrawImage missile, mx, my
			If my < mmax And my < ScrHeight Then
				my = my + 2
				build_i = Floor(mx/20)+1
				build_i2 = Floor((mx+ImageWidth(missile))/20)+1
				build_j = (ScrHeight - (my+ImageHeight(missile)))/20 + 1
				If build_j <= 2*ScrHeight/60 Then
					If BuildingArray(build_i,build_j) > 0 Then
						BuildingArray(build_i,build_j) = 0
						chnExplo = PlaySound(explosion_sound)
						score = score + level*5
						If build_j > 1 Then
							BuildingArray(build_i,build_j-1) = BuildingArray(build_i,build_j-1)+2
						End If
					End If	
					If BuildingArray(build_i2,build_j) > 0 Then
						BuildingArray(build_i2,build_j) = 0
						chnExplo = PlaySound(explosion_sound)
						score = score + level*5
						If build_j > 1 Then
							BuildingArray(build_i2,build_j-1) = BuildingArray(build_i2,build_j-1)+2
						End If
					End If
				End If
			Else
				showmissile = False
			End If
		End If

		If (Not gamewon) And (Not gameover) Then
			px = px + 2
			If px > ScrWidth Then
				px = -ImageWidth(ufo)
				py = py + ImageHeight(ufo)
			End If 
			If (ScrHeight - (py+ImageHeight(ufo)))/20 + 1 <= 2*ScrHeight/60 And Floor((px+ImageWidth(ufo))/20)+1 <= ScrWidth/20 Then
				build_i = Floor((px+ImageWidth(ufo))/20)+1
				build_j = (ScrHeight - (py+ImageHeight(ufo)))/20 + 1
				If BuildingArray(build_i,build_j) > 0 Then
					gameover = True
				End If
			End If
			If py >= ScrHeight - ImageHeight(ufo) Then
				py = ScrHeight - ImageHeight(ufo)
				If px > 2*ScrWidth/3 Then
					gamewon = True
				End If
			End If
		End If
	
		If KeyHit(57) Then    ;space bar
			If (Not showmissile) And (Not gamewon) And (Not gameover) Then 
				showmissile = True
				mx = px + ImageWidth(ufo)/2
				my = py + ImageHeight(ufo)
				mmax = my + missilerange
				chnMiss = PlaySound(missile_sound)
			Else If gameover Then
				nextlevel = False
				Exit
			Else If gamewon Then 
				nextlevel = True
				Exit
			End If
		End If
		
		For i = 1 To ScrWidth/20
			For j = 1 To 2*ScrHeight/60
				If BuildingArray(i,j) > 0 Then
					DrawImage skyscraper,(i-1)*20,ScrHeight-j*20,BuildingArray(i,j)-1
				End If
			Next
		Next
		
		If gamewon Then
			Color 255,255,255
			Text 320,FontHeight()*5,"Congratulations you have won this level",True
			Text 320,FontHeight()*7,"Bonus: "+100*level,True
			Text 320,FontHeight()*9,"Press space bar for the next level",True
			If Not applied Then
				score = score + 100*level
				applied = True
			End If
		End If
		
		If gameover Then
			Color 255,255,255
			Text 320,FontHeight()*5,"Sorry, game over - you have crashed",True
			If score >= bestscore Then
				Text 320,FontHeight()*7,"But you have achieved a new high score",True
				If Not saved Then
					bestscore = score
					;save score
					UserDataFile = WriteFile("Blitz.dat")
					WriteShort(UserDataFile, score)
    				CloseFile(UserDataFile)
					saved = True
				End If
			End If
		End If
		
		Flip
	
	Forever
	
	FreeTimer(frameTimer)
	
End Function

Function ExitGame()

	FreeImage ufo
	FreeImage missile
	FreeImage skyscraper
	FreeImage MenuBackground
	FreeImage GameBackground
	
	FreeSound ufo_sound
	FreeSound missile_sound
	FreeSound explosion_sound

End Function

End